<script setup lang="ts">
import InstitutionEdit from '@/components/InstitutionEdit.vue';
import UserPassword from '@/components/UserPassword.vue';
import UserPreview from '@/components/UserPreview.vue';
import UserQRCode from '@/components/UserQRCode.vue';
import { type InstitutionModel, type InstitutionQuery } from '@/model/system.model';

import { branchMethod, institutionMethod, editInstitutionMethod, deleteInstitutionMethod } from '@/request/api/system.api';
import { usePagination, useRequest } from 'alova/client';
import { notification } from 'ant-design-vue';

import { VxeButton, type VxeFormListeners, type VxeFormProps, type VxeGridInstance, type VxeGridListeners, type VxeGridProps, VxeUI } from 'vxe-pc-ui';

const { data: branch, loading: branchLoading } = useRequest(branchMethod);
const organizationOptions = ref<{ label: string; value: string }[]>([
  { label: 'liuzhi', value: '1' },
  { label: 'alice', value: '2' },
]);
const model = shallowRef<InstitutionQuery>();
const searchFormProps = reactive<VxeFormProps<InstitutionQuery>>({
  titleWidth: 100,
  titleAlign: 'right',
  titleColon: true,
  data: {},
  items: [
    { field: 'userName', title: '组织名称', span: 8, itemRender: { name: 'VxeSelect', props: { options: organizationOptions, optionProps: { value: 'value', label: 'label' } } } },
    { field: 'nickName', title: '机构名称', span: 8, itemRender: { name: 'VxeInput' } },
    {
      span: 8,
      itemRender: {
        name: 'VxeButtonGroup',
        options: [
          { type: 'submit', content: '查询', status: 'primary' },
          { type: 'reset', content: '清空' },
        ],
      },
    },
  ],
});
const searchFormEmits: VxeFormListeners<InstitutionQuery> = {
  submit({ data }) {
    model.value = { ...data };
  },
  reset({ data }) {
    model.value = { ...data };
  },
};

const gridRef = ref<VxeGridInstance<InstitutionModel>>();
const gridOptions = reactive<VxeGridProps<InstitutionModel>>({
  id: 'user-list',
  border: true,
  showOverflow: true,
  height: 'auto',
  autoResize: false,
  syncResize: true,
  scrollY: { enabled: true, gt: 0 },
  toolbarConfig: {
    custom: true,
    zoom: true,
    slots: {
      buttons: 'handle',
      tools: 'toolbar-extra',
    },
  },
  columnConfig: {
    resizable: true,
  },
  customConfig: {
    storage: true,
  },
  columns: [
    { type: 'seq', width: 70, fixed: 'left' },
    { field: 'name', title: '机构名称' },
    { field: 'parentName', title: '上级机构' },
    { field: 'orgName', title: '组织名称' },
    { field: 'createTime', title: '创建时间' },
    { field: 'createBy', title: '创建者' },
    {
      title: '操作',
      align: 'center',
      width: 180,
      showOverflow: false,
      cellRender: {
        name: 'VxeButtonGroup',
        props: {
          mode: 'text',
        },
        options: [
          { content: '修改', status: 'warning', name: 'editInstitution' },
          { content: '删除', status: 'error', name: 'deleteInstitution' },
          { content: '小程序码', status: 'primary', name: 'QRCode' },
        ],
        events: {
          click({ row, rowIndex }, { name }) {
            let method;
            if (name === 'editInstitution') {
              method = editInstitution;
            } else if (name === 'deleteInstitution') {
              method = deleteInstitution;
            } else if (name === 'QRCode') {
              method = QRCode;
            }
            method?.(row, rowIndex);
          },
        },
      },
    },
  ],
  data: [],
});

const { loading, page, pageSize, total, onSuccess, replace, refresh, remove } = usePagination((page, size) => institutionMethod(page, size, model.value), {
  initialData: { data: [], total: 0 },
  initialPage: 1,
  initialPageSize: 100,
  watchingStates: [model],
  immediate: false,
});
onSuccess(({ data: { data } }) => {
  gridRef.value?.loadData(data);
});

onMounted(() => {
  model.value = toRaw(searchFormProps.data);
});

function deleteInstitution(model: InstitutionModel, index: number) {
  const { name } = model;
  VxeUI.modal.confirm({
    title: `删除机构`,
    content: `确认要删除 ${name} 机构吗？`,
    showClose: false,
    onConfirm() {
      deleteInstitutionMethod(model).then(() => {
        notification.success({
          message: `删除机构: ${name}`,
          description: '操作成功',
        });
        refresh(page.value);
      });
    },
  });
}

function editInstitution(model?: InstitutionModel, index?: number) {
  VxeUI.modal.open({
    title: model?.id ? `修改机构` : `新增机构`,
    escClosable: true,
    destroyOnClose: true,
    id: `institution-edit-modal`,
    remember: true,
    storage: true,
    slots: {
      default() {
        return h(InstitutionEdit, <any>{
          data: model,
          onSubmit(data?: InstitutionModel) {
            refresh(page.value);
            VxeUI.modal.close(`institution-edit-modal`);
          },
        });
      },
    },
  });
}

function QRCode(model: InstitutionModel) {
  const { name } = model;
  VxeUI.modal.open({
    title: `${name} 专属小程序码`,
    escClosable: true,
    destroyOnClose: true,
    id: `user-preview-qr-code`,
    remember: true,
    storage: true,
    padding: false,
    width: 256 + 12 * 2,
    slots: {
      default() {
        return h(UserQRCode, <any>{
          dataset: model,
        });
      },
    },
  });
}
</script>
<template>
  <div class="page-container flex flex-col">
    <header class="flex-none">
      <vxe-form v-bind="searchFormProps" v-on="searchFormEmits" />
    </header>
    <main class="flex-auto overflow-hidden">
      <vxe-grid ref="gridRef" v-bind="gridOptions" v-on="gridEvents" :loading="loading">
        <template #handle>
          <vxe-button status="primary" permission-code="system:user:add" @click="editInstitution()">新增</vxe-button>
        </template>
        <template #toolbar-extra>
          <vxe-button style="margin-right: 12px" icon="vxe-icon-repeat" circle @click="refresh(page)"></vxe-button>
        </template>
      </vxe-grid>
    </main>
    <footer class="flex-none">
      <vxe-pager
        v-model:current-page="page"
        v-model:page-size="pageSize"
        :total="total"
        :layouts="['Home', 'PrevJump', 'PrevPage', 'Number', 'NextPage', 'NextJump', 'End', 'Sizes', 'FullJump', 'Total']"
      />
    </footer>
  </div>
</template>
<style scoped lang="scss">
.page-container {
  padding: 0 24px;
  max-height: var(--page-main-container);
}
</style>
